C****************************************************************
C*****OEVING 1, VAAR 2007 *****     DELVIS LOESNINGSFORSLAG *****
C****************************************************************
C
C****************************************************************
C****** OBS, OBS! DENNE KODEN ER SKREVET I FORTRAN 77************
C****************************************************************
C
C	LOESNING AV EN TILSTANDSLIGNING VED BRUK AV NEWTONS METODE
C	
C	FOR GITT TEMPERATUR OG TRYKK, BEREGNER DETTE PROGRAMMET
C	MOLARVOLUMET FOR EN GASS FRA BEATTIE-BRIDGEMAN-LIGNINGEN
C	VED HJELP AV NEWTONSK ITERASJON.
C
C	A, ANULL, B, BNULL, C = EMPIRISKE KONSTANTER SOM ER 
C	                        FORSKJELLIGE FOR HVER GASS. (LESES INN)
C	BETA, GAMMA, OG DELTA = TEMPERATURAVHENGIGE PARAMETRE. 
C	R 		      = UNIVERSAL GASSKONSTANT (LESES INN)
C	ITER 	= ITERASJONSTELLER (LESES INN) 
C	EPS 	= KONVERGENSKRITERIUM (LESES INN)
C	RE 	= ABSOLUTTVERDIEN AV DEN RELATIVE ENDRINGEN I VOLUM
C		  MELLOM TO ITERASJONER
C	KMAX 	= MAKSIMUM ANTALL ITERASJONER TILLATT (LESES INN)
C       NN 	= ANTALL SETT AV TRYKK OG TEMPERTUR SOM SKAL LESES
C
C	V 		= MOLARVOLUM
C	P 		= TRYKK (ATM) (LESES INN)
C	TC 		= TEMPERATUR (CELSIUS) (LESES INN)
C	T 		= TEMPERATUR (KELVIN)
C	
C	FOERSTE ESTIMAT FOR VOLUM ER BEREGNET FRA DEN IDEELLE GASSLOVEN
C	ETTER AT KONVERGENS ER OPPNAADD, BEREGNES KOMPRESSIBILITETSFAKTOR
C	 
C-----DEKLARASJONER
C      
      REAL P(28),TC(28),Z(28)
      REAL A,ANULL,B,BNULL,C,BETA,GAMMA,DELTA,R,EPS,RE,V,DV,T
      INTEGER I,J,L,ITER,KMAX,NN
C
C-----AAPNE FILER
C
      her skal kommandoene for aapning av inn- og utfiler skrives
      bruk enhetsnr. 10 for innfil og 11 for utfil

C
C-----LES OG SKRIV FASTE PARAMETRE
C
      skriv kommandoene for innlesing fra enhet 10 og utskrift av
      innleste data til enhet 11

C
C---------------------------LES ANTALL DATASETT

      her skrives innlesningskommando for antall datasett fra enhet 10

C---------------------------LOEKKE FOR INNLESNING AV T,P OG BEREGNINGER
C                           SAMT UTSKRIFT
      DO 50 L=1,NN
C---------------------------LES TEMPERATUR OG TRYKK

      skriv kommando fo innlesing av P(L) og TC(L) fra enhet 11

C---------------------------BEREGN PARAMETRE

      her beregnes parametrene

C---------------------------FOERSTE ESTIMAT FRA IDEELL GASSLOV
      
      skriv formel for foerste estimat

C---------------------------BEGYNN NEWTONSK ITERASJON
      DO 40 K=1,ITMAX

      skriv formlene for Newtonsk iterasjon

C---------------------------SJEKK FOR KONVERGENS

      sjekk om forskjellen mellom to iterasjoner er mindre enn EPS

C---------------------------BEREGN KOMPRESSIBILITETSFAKTOR

      skriv formel for Z-faktor

C---------------------------UTSKRIFT

      lag utskriftskommando for TC(L),P(L),Z(L) og K
      GO TO 50
   40 CONTINUE
      WRITE(11,202)
   50 CONTINUE
C
  100 FORMAT(3(10X,F8.5,2X)/10X,F8.5,12X,F8.0,12X,F8.5/10X,E6.1,14X,I2)
  101 FORMAT(10X,F6.2,14X,F6.2)
  200 FORMAT(" INNLESTE PARAMETRE FOR METAN:",/,
     *10H A      = ,F14.5/10H ANULL  = ,F14.5/10H B      = ,
     *F14.5/ 10H BNULL  = ,F14.5/ 10H C      = , F14.5/ 10H R      = ,
     *F14.5/ 10H EPS    = ,1PE14.1/10H  KMAX  = ,I8,/,/, 
     *" TEMPERATUR, TRYKK OG BEREGNET Z-FAKTOR,",
     *" SAMT ANTALL ITERASJONER BRUKT:",/,
     *40H     TC         P         Z     ITER        )
  201 FORMAT(2F10.3,F10.6,I5)
  202 FORMAT(17H0 IKKE KONVERGENS)
C
      END
